commit d4521980eb466bdf5945d4c08e348304e672f6de
Author: jklowden <jklowden>
Date:   Mon Mar 2 05:39:44 2009 +0000

    bcp_init sets default values for host file columns if host_filename is not NULL.

diff --git a/ChangeLog b/ChangeLog
index 48941f4..56501f3 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,9 @@
+Mon Mar  2 00:09:58 EST 2009	JK Lowden <jklowden@freetds.org>
+	* src/dblib/bcp.c src/dblib/dblib.c
+	* samples/bcp_test.cpp samples/Makefile.bcp_test
+	- bcp_init sets default values for host file columns
+	- if host_filename is not NULL.
+
 Sat Feb 28 12:32:06 EST 2009	JK Lowden <jklowden@freetds.org>
 	* include/sybdb.h DBDATEREC members are 32-bit
 	* BUGS TODO more things to fix
@@ -1354,4 +1360,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2735 2009/02/28 17:38:38 jklowden Exp $
+$Id: ChangeLog,v 1.2736 2009/03/02 05:39:44 jklowden Exp $
diff --git a/samples/Makefile.bcp_test b/samples/Makefile.bcp_test
new file mode 100644
index 0000000..bef6616
--- /dev/null
+++ b/samples/Makefile.bcp_test
@@ -0,0 +1,12 @@
+# This file is not part of Makefile.am because the source code is C++, 
+# and FreeTDS requires only a C compiler.  
+#
+
+DBLIB_H = /usr/local
+DBLIB_L = ../build/src/dblib/.libs
+FLAGS = -D MSDBLIB -fmessage-length=$$(stty -a | awk '/^speed/ {print $$6}')
+INC = -I $(DBLIB_H)/include
+LIB = -L $(DBLIB_L) -Wl,-R$(DBLIB_L) -lsybdb
+
+bcp_test: bcp_test.cpp
+	$(CXX) -o $@ bcp_test.cpp -g -O0 $(FLAGS) $(INC) $(LIB)
diff --git a/samples/bcp_test.cpp b/samples/bcp_test.cpp
new file mode 100644
index 0000000..de345de
--- /dev/null
+++ b/samples/bcp_test.cpp
@@ -0,0 +1,346 @@
+#ifdef _WIN32
+	#ifndef _CRT_SECURE_NO_WARNINGS
+	//	define _CRT_SECURE_NO_WARNINGS
+	#endif
+	#ifndef _WIN32_WINNT
+	#define _WIN32_WINNT 0x0400
+	#endif
+
+	#include <windows.h>
+#endif // _WIN32
+
+#include <sqlfront.h>
+#include <sqldb.h>
+
+#include <cassert>
+
+#include <iostream>
+#include <iomanip>
+#include <fstream>
+#include <sstream>
+
+using namespace std;
+
+#if defined(_INC_SQLFRONT)
+#define MSGNO_T DBINT
+#define MSGNO_LINE DBUSMALLINT
+#else
+#define MSGNO_T int
+#define MSGNO_LINE int
+#define LPCSTR char*
+#define LPCBYTE unsigned char*
+#endif	// _INC_SQLFRONT
+
+/*
+ * Classes for reading the native bcp data file
+ */
+struct counted_string : public std::string
+{};
+
+istream&
+operator>>( istream& is, counted_string& output ) 
+{
+	unsigned char len;
+	is.read( reinterpret_cast<char*>(&len), sizeof(len) );
+	streamsize nread = is.gcount();
+	assert(is.good() && nread == 1);
+	char buf[80];
+	if( sizeof(buf) <= len ){
+		cerr << "error reading counted_string at offset 0x" << hex << is.tellg() << "; "
+			 << "len = 0x" << hex << (unsigned short)len << ", should be <= 30\n";
+			 abort();  
+	}
+	nread = is.readsome( buf, len );
+	assert(len == nread);
+	buf[len] = '\0';
+	std::string& that(output);
+	that = buf;
+	return is;
+}
+
+template <typename T>
+struct number
+{
+	T datum;
+	number() : datum(0) {}
+};
+
+template <typename T>
+istream&
+operator>>( istream& is, number<T>& output ) 
+{
+	static const streamsize len(sizeof(T));
+	streamsize nread = is.readsome( reinterpret_cast<char*>(&output.datum), len );
+	assert(is.good() && len == nread);
+	return is;
+}
+
+template <typename T>
+ostream&
+operator<<( ostream& os, const number<T>& input ) 
+{
+	return os << input.datum;
+}
+
+istream&
+operator>>( istream& is, DBDATETIME& dt ) 
+{
+	streamsize nread = is.readsome( reinterpret_cast<char*>(&dt), sizeof(dt) );
+	assert(is.good() && sizeof(dt) == nread);
+	
+	return is;
+}
+
+ostream&
+operator<<( ostream& os, DBDATETIME& dt ) 
+{
+	DBDATEREC date;
+	RETCODE erc = dbdatecrack( 0, &date, &dt );
+	assert(erc == SUCCEED);
+
+	os << setfill('0') << right 
+	   << date.year 
+	   << '-' << setw(2) << (1+date.month)
+	   << '-' << setw(2) << date.day 
+	   << ' ' << setw(2) << date.hour 
+	   << ':' << setw(2) << date.minute
+	   << setfill(' ');	
+	return os;
+}
+
+/*
+ * Error and Message handlers
+ */
+int
+ErrorHandler(	PDBPROCESS	dbproc 
+			  , DBINT		severity
+			  , DBINT		dberr 
+			  , DBINT		oserr 
+			  , LPCSTR		dberrstr
+			  , LPCSTR		oserrstr
+			  )
+{
+		cerr  << "DB-Library error " << dberr << " (severity " << severity << "):\n";
+		cerr  << "dbproc:\t"		<< dbproc 			<< '\n'
+			  << "message:\t"		<< dberrstr 	<< '\n';
+		if( oserr ) {
+			cerr	<< "OS error "	<< oserr 	<< ": "	<< oserrstr << '\n';
+		}
+		return INT_CANCEL;
+}
+
+int
+MessageHandler(	  PDBPROCESS	dbproc
+				, MSGNO_T		msgno 
+				, DBINT			msgstate 
+				, DBINT			severity 
+				, LPCSTR		msgtext 
+				, LPCSTR		srvname 
+				, LPCSTR		procname 
+				, MSGNO_LINE	line 
+				)
+{
+	switch(msgno) {
+	case 5701:
+	case 5703:
+		return 0;
+	} 
+	if( msgno > 0 ) {
+		cerr	<< "Error "		<< msgno 
+				<< " (severity " << severity << ") " 
+				<< "from "		<< srvname;
+	}
+
+	if( procname )	// potentially empty, std::string()
+		cerr << ".." << procname << "(line " << line << ")";
+	cerr << '\n';
+
+	cerr	<< "dbproc:\t"		<< dbproc			<< '\n'
+		<< "message:\t"		<< msgtext 	<< '\n';
+
+	return 0;
+}
+
+/*
+ * Data and row buffer types
+ */
+struct data_t {
+	char *name;
+	short type;
+	double ftype;
+	char *date;
+} data[] = {
+	  {"AddressLine", 39, 3.9, "Feb 27 2009  2:39PM" }
+	, {"Date",        58, 5.8, "Feb 27 2009  2:39PM" }
+	, {"DateOnly",    61, 6.1, "Feb 27 2009  2:39PM" }
+	, {"Handle",      39, 3.9, "Feb 27 2009  2:39PM" }
+};
+struct buf_t : public data_t
+{
+	enum{ MAX_NAME = 32 };
+	buf_t() {
+		name = new char(MAX_NAME);
+		date = new char(MAX_NAME);
+	}
+	buf_t& operator=( const data_t& that ) {
+		assert( that.name && MAX_NAME > strlen(that.name) );
+		assert( that.date && MAX_NAME > strlen(that.date) );
+		strcpy( name, that.name );
+		strcpy( date, that.date );
+		type = that.type;
+		ftype = that.ftype;
+		return  *this;
+	}
+};
+
+static const char drop_table[] = 	"if object_id('xsystypes') is not NULL "
+									"	drop table xsystypes";
+static const char create_table[] = 	"CREATE TABLE xsystypes "
+									"	( name varchar(30)   NOT NULL "
+									"	, type int           NOT NULL "
+									"	, ftype float        NOT NULL "
+									"	, date datetime      NOT NULL "
+									"   ) ";
+
+#ifdef _WIN32
+const bool fwin32(true);
+#else
+const bool fwin32(false);
+#endif
+
+void
+execute( DBPROCESS * dbproc ) 
+{
+	RETCODE erc = dbsqlexec(dbproc);
+	assert( erc == SUCCEED );
+	
+	while( (erc = dbresults(dbproc)) != NO_MORE_RESULTS ){
+		assert( erc == SUCCEED );
+		dbprhead(dbproc);
+		while( (erc = dbnextrow(dbproc)) != NO_MORE_ROWS ) {
+			assert( erc == SUCCEED );
+			dbprrow(dbproc);
+		}
+	}
+}
+
+int main( int argc, char *argv[] ) 
+{
+	cout << "initialized DB-Library: " << dbinit() << endl;
+
+	dberrhandle(ErrorHandler);
+	dbmsghandle(MessageHandler);
+
+	LOGINREC * login = dblogin();
+	DBSETLSECURE (login);
+	BCP_SETL (login, 1);
+	
+	if( argc < 3 || argc < 5 && !fwin32 ) {
+		cerr << "syntax: " << argv[0] << " server database [user] [password]\n";
+		return 1;
+	}
+
+	const char * server = argv[1];
+	const char * dbname = argv[2];
+	const char * username = argc > 3? argv[3] : NULL;
+	const char * password = argc > 4? argv[4] : NULL;
+
+	if( username ) {
+		DBSETLUSER (login, username);
+		if( password ) 
+			DBSETLPWD (login, password);
+	} else {
+		DBSETLSECURE (login);
+	}
+
+	DBPROCESS *dbproc = dbopen( login, server );
+	assert( dbproc );
+
+	RETCODE erc = dbuse(dbproc, dbname);
+	assert( erc == SUCCEED );
+
+	/* 
+	 * Create the table "xsystypes"
+	 */
+	erc = dbcmd(dbproc, drop_table );
+	assert( erc == SUCCEED );
+	execute(dbproc);
+
+	erc = dbcmd(dbproc, "BEGIN TRANSACTION ");
+	assert( erc == SUCCEED );
+	erc = dbcmd(dbproc, create_table );
+	assert( erc == SUCCEED );
+	
+	execute(dbproc);
+	
+	/* 
+	 * Prepare to write from memory
+	 */
+	erc = bcp_init( dbproc, "xsystypes", NULL, NULL, DB_IN );
+	assert( erc == SUCCEED );
+
+	buf_t buf;
+
+	LPCBYTE null_term = (BYTE*)"";
+
+	//                      addr              pre vlen term      tlen  type       col
+	erc = bcp_bind( dbproc, (LPCBYTE) buf.name,  0, -1, null_term,  1, SQLVARCHAR, 1 );
+	assert( erc == SUCCEED );
+	erc = bcp_bind( dbproc, (LPCBYTE)&buf.type,  0, -1,  0,         0, SQLINT2, 2 );
+	assert( erc == SUCCEED );
+	erc = bcp_bind( dbproc, (LPCBYTE)&buf.ftype, 0, -1,  0,         0, SQLFLT8, 3 );
+	assert( erc == SUCCEED );
+	erc = bcp_bind( dbproc, (LPCBYTE) buf.date,  0, -1, null_term,  1, SQLVARCHAR, 4 );
+	assert( erc == SUCCEED );
+
+	/* 
+	 * Send the data.
+	 */
+	for( int i=0; i < sizeof(data)/sizeof(data[0]); i++ ) {
+		buf = data[i];
+		erc = bcp_sendrow( dbproc );
+		assert( erc == SUCCEED );
+	}
+
+	cout << bcp_done(dbproc) << " rows sent" << endl;
+
+	erc = dbcmd(dbproc, "COMMIT TRANSACTION ");
+	assert( erc == SUCCEED );
+	execute(dbproc);
+	
+	/* 
+	 * Prepare to extract the data to the file "xsystypes.dat".
+	 */
+	char datafilename[] = "xsystypes.dat";
+	erc = bcp_init( dbproc, "xsystypes", datafilename, "xsystypes.err", DB_OUT );
+	assert( erc == SUCCEED );
+	
+	DBINT nrows;
+	erc = bcp_exec( dbproc, &nrows );
+	assert( erc == SUCCEED );
+	
+	cout << nrows << " rows extracted to " << datafilename << "\n";
+
+	erc = dbcmd(dbproc, "DROP TABLE xsystypes ");
+	assert( erc == SUCCEED );
+	execute(dbproc);
+	
+	/*
+	 * Print the data file.
+	 */ 
+	ifstream datafile(datafilename);
+	assert(datafile.is_open());
+	for( int i=0; i < sizeof(data)/sizeof(data[0]); i++ ) {
+		counted_string name;
+		DBDATETIME date;
+		number<int> type;
+		number<double> ftype;
+		
+		datafile >> name >> type >> ftype >> date;
+		cout << left << setw(30) << name << '\t' << type << '\t' << ftype << '\t' << date << endl;
+	}
+	
+	return 0;
+}
+
+	
diff --git a/src/dblib/bcp.c b/src/dblib/bcp.c
index 9303dd2..6f686f7 100644
--- a/src/dblib/bcp.c
+++ b/src/dblib/bcp.c
@@ -61,7 +61,7 @@
 #define MAX(a,b) ( (a) > (b) ? (a) : (b) )
 #endif
 
-TDS_RCSID(var, "$Id: bcp.c,v 1.181 2009/02/26 19:04:10 freddy77 Exp $");
+TDS_RCSID(var, "$Id: bcp.c,v 1.182 2009/03/02 05:39:45 jklowden Exp $");
 
 #ifdef HAVE_FSEEKO
 typedef off_t offset_type;
@@ -94,6 +94,57 @@ static RETCODE _bcp_read_hostfile(DBPROCESS * dbproc, FILE * hostfile, int *row_
 static int _bcp_readfmt_colinfo(DBPROCESS * dbproc, char *buf, BCP_HOSTCOLINFO * ci);
 static RETCODE _bcp_get_term_var(BYTE * pdata, BYTE * term, int term_len);
 
+/*
+ * "If a host file is being used ... the default data formats are as follows:
+ *
+ *  > The order, type, length and number of the columns in the host file are 
+ *    assumed to be identical to the order, type and number of the columns in the database table.
+ *  > If a given database column's data is fixed-length, 
+ *    then the host file's  data column will also be fixed-length. 
+ *  > If a given database column's data is variable-length or may contain null values, 
+ *    the host file's data column will be prefixed by 
+ *	a 4-byte length value for SYBTEXT and SYBIMAGE data types, and 
+ *	a 1-byte length value for all other types.
+ *  > There are no terminators of any kind between host file columns."
+ */
+
+static void
+init_hostfile_columns(DBPROCESS *dbproc)
+{
+	const int ncols = dbproc->bcpinfo->bindinfo->num_cols;
+	RETCODE erc;
+	int icol;
+	
+	if (ncols == 0)
+		return;
+		
+	if ((erc = bcp_columns(dbproc, ncols)) != SUCCEED) {
+		assert(erc == SUCCEED);
+		return;
+	}
+		
+	for (icol = 0; icol < ncols; icol++) {
+		const TDSCOLUMN *pcol = dbproc->bcpinfo->bindinfo->columns[icol];
+		int prefixlen = 0, termlen = 0;
+		
+		switch (pcol->column_type) {
+		case SYBTEXT:
+		case SYBIMAGE:
+			prefixlen = 4;
+			break;
+		default:
+			prefixlen = dbvarylen(dbproc, icol+1)? 1 : 0;
+		}
+		
+		erc = bcp_colfmt(dbproc, icol+1, pcol->column_type, prefixlen, pcol->column_size, NULL, termlen, icol+1);
+		
+		assert(erc == SUCCEED);
+		if (erc != SUCCEED)
+			return;
+	}
+}
+
+
 /** 
  * \ingroup dblib_bcp
  * \brief Prepare for bulk copy operation on a table
@@ -152,22 +203,6 @@ bcp_init(DBPROCESS * dbproc, const char *tblname, const char *hfile, const char
 		return (FAIL);
 	}
 
-	if (hfile != NULL) {
-
-		dbproc->hostfileinfo = calloc(1, sizeof(BCP_HOSTFILEINFO));
-
-		if (dbproc->hostfileinfo == NULL)
-			goto memory_error;
-		if ((dbproc->hostfileinfo->hostfile = strdup(hfile)) == NULL)
-			goto memory_error;
-
-		if (errfile != NULL)
-			if ((dbproc->hostfileinfo->errorfile = strdup(errfile)) == NULL)
-				goto memory_error;
-	} else {
-		dbproc->hostfileinfo = NULL;
-	}
-
 	/* Allocate storage */
 	
 	dbproc->bcpinfo = calloc(1, sizeof(TDSBCPINFO));
@@ -183,10 +218,8 @@ bcp_init(DBPROCESS * dbproc, const char *tblname, const char *hfile, const char
 	dbproc->bcpinfo->var_cols   = 0;
 	dbproc->bcpinfo->bind_count = 0;
 
-	if (direction == DB_IN) {
-		TDSSOCKET *tds = dbproc->tds_socket;
-
-		if (tds_bcp_init(tds, dbproc->bcpinfo) == TDS_FAIL) {
+	if (1 || direction == DB_IN) {
+		if (tds_bcp_init(dbproc->tds_socket, dbproc->bcpinfo) == TDS_FAIL) {
 			/* TODO return proper error */
 			/* Attempt to use Bulk Copy with a non-existent Server table (might be why ...) */
 			dbperror(dbproc, SYBEBCNT, 0);
@@ -194,6 +227,26 @@ bcp_init(DBPROCESS * dbproc, const char *tblname, const char *hfile, const char
 		}
 	}
 
+	/* Prepare default hostfile columns */
+	
+	if (hfile == NULL) {
+		dbproc->hostfileinfo = NULL;
+		return SUCCEED;
+	}
+
+	dbproc->hostfileinfo = calloc(1, sizeof(BCP_HOSTFILEINFO));
+
+	if (dbproc->hostfileinfo == NULL)
+		goto memory_error;
+	if ((dbproc->hostfileinfo->hostfile = strdup(hfile)) == NULL)
+		goto memory_error;
+
+	if (errfile != NULL)
+		if ((dbproc->hostfileinfo->errorfile = strdup(errfile)) == NULL)
+			goto memory_error;
+
+	init_hostfile_columns(dbproc);
+
 	return SUCCEED;
 
 memory_error:
@@ -701,36 +754,27 @@ _bcp_exec_out(DBPROCESS * dbproc, DBINT * rows_copied)
 	tds = dbproc->tds_socket;
 	assert(tds);
 
-	if (!(hostfile = fopen(dbproc->hostfileinfo->hostfile, "w"))) {
-		dbperror(dbproc, SYBEBCUO, errno);
-		return FAIL;
-	}
-
 	bcpdatefmt = getenv("FREEBCP_DATEFMT");
 	if (!bcpdatefmt)
 		bcpdatefmt = "%Y-%m-%d %H:%M:%S.%z";
 
 	if (dbproc->bcpinfo->direction == DB_QUERYOUT ) {
 		if (tds_submit_query(tds, dbproc->bcpinfo->tablename) == TDS_FAIL) {
-			fclose(hostfile);
 			return FAIL;
 		}
 	} else {
 		/* TODO quote if needed */
 		if (tds_submit_queryf(tds, "select * from %s", dbproc->bcpinfo->tablename) == TDS_FAIL) {
-			fclose(hostfile);
 			return FAIL;
 		}
 	}
 
 	tdsret = tds_process_tokens(tds, &result_type, NULL, TDS_TOKEN_RESULTS);
 	if (tdsret == TDS_FAIL || tdsret == TDS_CANCELLED) {
-		fclose(hostfile);
 		return FAIL;
 	}
 	if (!tds->res_info) {
 		/* TODO flush/cancel to keep consistent state */
-		fclose(hostfile);
 		return FAIL;
 	}
 
@@ -861,21 +905,27 @@ _bcp_exec_out(DBPROCESS * dbproc, DBINT * rows_copied)
 		hostcol->bcp_column_data->datalen = destlen;
 	}
 
-	/* fetch a row of data from the server */
-
 	/*
 	 * TODO above we allocate many buffer just to convert and store 
 	 * to file.. avoid all that passages...
 	 */
 
-	while (tds_process_tokens(tds, &result_type, NULL, TDS_STOPAT_ROWFMT|TDS_RETURN_DONE|TDS_RETURN_ROW|TDS_RETURN_COMPUTE) == TDS_SUCCEED) {
+	if (!(hostfile = fopen(dbproc->hostfileinfo->hostfile, "w"))) {
+		dbperror(dbproc, SYBEBCUO, errno);
+		return FAIL;
+	}
+
+	/* fetch a row of data from the server */
+
+	while (tds_process_tokens(tds, &result_type, NULL, TDS_STOPAT_ROWFMT|TDS_RETURN_DONE|TDS_RETURN_ROW|TDS_RETURN_COMPUTE) 
+		== TDS_SUCCEED) {
 
 		if (result_type != TDS_ROW_RESULT && result_type != TDS_COMPUTE_RESULT)
 			break;
 
 		row_of_query++;
 
-		/* skip rows outside of the firstrow/lastrow range , if specified */
+		/* skip rows outside of the firstrow/lastrow range, if specified */
 		if (dbproc->hostfileinfo->firstrow <= row_of_query && 
 						      row_of_query <= MAX(dbproc->hostfileinfo->lastrow, 0x7FFFFFFF)) {
 
diff --git a/src/dblib/dblib.c b/src/dblib/dblib.c
index db40841..8db9f20 100644
--- a/src/dblib/dblib.c
+++ b/src/dblib/dblib.c
@@ -75,7 +75,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: dblib.c,v 1.341 2009/02/07 00:26:22 jklowden Exp $");
+TDS_RCSID(var, "$Id: dblib.c,v 1.342 2009/03/02 05:39:45 jklowden Exp $");
 
 static RETCODE _dbresults(DBPROCESS * dbproc);
 static int _db_get_server_type(int bindtype);
@@ -1097,6 +1097,8 @@ tdsdbopen(LOGINREC * login, const char *server, int msdblib)
 
 	tdsdump_log(TDS_DBG_FUNC, "dbopen(%p, %s, [%s])\n", login, server, msdblib? "microsoft" : "sybase");
 
+	CHECK_NULP(server, dbopen, 2, 0);
+	
 	if ((dbproc = calloc(1, sizeof(DBPROCESS))) == NULL) {
 		dbperror(NULL, SYBEMEM, errno);
 		return NULL;

